from visual.text import *

# Display extruded text (uppercase only at present)
# By default, display text along x axis, with letters pointing up parallel to y axis
# Bruce Sherwood, Carnegie Mellon University, begun March 2000

# Example with default values:
#  text(pos=(0,0,0), axis=(1,0,0), string='ABC',
#    height=1, depth=0, width=1,
#    color=currentdisplay.foreground, up=(0,1,0.3))
# axis is direction along which text advances
# if width not specified, it is the same as height
# depth is measured forward from pos
# Only numbers and uppercase letters at present: others display as '*'

scene.title = "3D Text"
scene.fov = 0.001
at = (-4,2,3)
str = '+0123456789'
t1 = text(pos=at, color=color.green, string=str, justify='center')

t2 = text(pos=(-4,3.1,3), string='AB-CD', color=color.yellow, justify='center')

at = (-10,0,0)
str = 'ROTATED AXIS AND UP VECTOR'

t3 = text(pos=at, string=str, color=(1,0,0), axis=(1,0,1),
                depth=0.3, up=(0,1,-0.3))
