"""Module utest: Testing automation"""

import sys, os

class tee:
    def __init__(self, a, b):
        self.a = a
        self.b = b

    def write(self, what):
        self.a.write(what)
        self.b.write(what)

class compare:
    def __init__(self, out, std):
        self.out = out
        self.std = std

    def write(self, what):
        std = self.std.read(len(what))
        if std != what:
            sys.stderr.write("\nExpected:\n%s\nGot:\n%s\n" % (std,what))
        else:
            self.out.write(what)

    def __del__(self):
        std = self.std.read()
        what = ""
        if std != what:
            sys.stderr.write("\nExpected:\n%s\nGot:\n%s\n" % (std,what))
        

main_name = sys.argv[0]
test_name = os.path.splitext(main_name)[0] + '.test'

try:
    test = open(test_name, 'r')
    print "Testing", main_name, "against", test_name
    sys.stdout = compare(sys.stdout, test)
except IOError:
    test = open(test_name, 'w')
    print "Generating test file", test_name, "for", main_name
    print "Check the output by hand!"
    sys.stdout = tee(sys.stdout, test)

if __name__ == "__main__":
    print "Testing myself."
